﻿using System;
using System.Collections.Generic;
using System.Windows.Forms;

namespace Meibo1 {
  public partial class Form1 : Form {
    public Form1() {
      InitializeComponent();
    }

    List<Person> MainData = new List<Person>();

    private void Form1_Load(object sender,
      EventArgs e) {

      const string dataFileName = "meibo1.csv";
      const string errorTitle = "エラー";
      this.Text = "名簿";
      var myEnconding = System.Text.Encoding.
        GetEncoding("Shift_JIS");
      string input = "";
      try {
        input = System.IO.File.ReadAllText(
          dataFileName, myEnconding);
      } catch (Exception ex) {
        MessageBox.Show(ex.Message, errorTitle);
        Application.Exit();
      }

      var lines = input.Split(new string[] { 
        Environment.NewLine },
        System.StringSplitOptions.RemoveEmptyEntries);
      foreach (var line in lines) {
        var columns = line.Split(',');
        Person p = null;
        try {
          p = new Person(columns[0], columns[1]);
        } catch (Exception ex) {
          MessageBox.Show(dataFileName + "の" +
            (MainData.Count + 1) + "行め「" + line +
            "」に問題があります" +
            Environment.NewLine + ex.Message,
            errorTitle);
          Application.Exit();
        }
        if (p != null) MainData.Add(p);
      }
    }
  }
}
