﻿using System;
using System.Windows.Forms;

namespace Meibo2 {
  public partial class Form1 : Form {
    public Form1() {
      InitializeComponent();
    }

    private void Form1_Load(
      object sender, EventArgs e) {

      this.Text = "名簿";
      var dg = dataGridView1;
      dg.Dock = DockStyle.Fill;
      string[] columnNames = new string[] {
        "#", "名前", "生年月日" };
      dg.ColumnCount = columnNames.Length;
      for (int i = 0; i < columnNames.Length; i++)
        dg.Columns[i].Name = columnNames[i];

      var myEncoding = System.Text.Encoding.
        GetEncoding("Shift_JIS");
      var input = System.IO.File.ReadAllText(
        "meibo1.csv", myEncoding);
      var lines = input.Split(
        new string[] { Environment.NewLine },
        StringSplitOptions.RemoveEmptyEntries);

      for (int i = 0; i < lines.Length; i++) {
        var line = (i + 1).ToString() + ',' +
          lines[i];
        var columns = line.Split(',');
        dg.Rows.Add(columns);
      }
    }

    private void buttonExit_Click(object sender, EventArgs e) {
      Application.Exit();
    }

    private void buttonShowVersion_Click(object sender, EventArgs e) {
      MessageBox.Show("名簿 Version 0.01", "バージョン情報");
    }
  }
}
