﻿using System;
using System.Diagnostics;
using System.Windows.Forms;

namespace Meibo2 {
  public partial class Form1 : Form {
    public Form1() {
      InitializeComponent();
    }

    private void Form1_Load(
      object sender, EventArgs e) {

      var sw = new Stopwatch();
      sw.Start();

      this.Text = "名簿";
      var dg = dataGridView1;
      dg.Dock = DockStyle.Fill;
      string[] columnNames = new string[] {
        "#", "名前", "生年月日" };
      dg.ColumnCount = columnNames.Length;
      for (int i = 0; i < columnNames.Length; i++)
        dg.Columns[i].Name = columnNames[i];

      var myEncoding = System.Text.Encoding.
        GetEncoding("Shift_JIS");
      var input = System.IO.File.ReadAllText(
        @"c:\temp\100.csv", myEncoding);
      var lines = input.Split(
        new string[] { Environment.NewLine },
        StringSplitOptions.RemoveEmptyEntries);

      //dg.Visible = false;
      for (int i = 0; i < lines.Length; i++) {
        var line = (i + 1).ToString() + ',' +
          lines[i];
        var columns = line.Split(',');
        dg.Rows.Add(columns);
      }
      //dg.Visible = true;
      //this.Height += 1;


      sw.Stop();
      var ts = new TimeSpan(
        sw.ElapsedMilliseconds * 10000);
      MessageBox.Show("処理に要した時間は" +
        ts.ToString(@"hh\:mm\:ss") + "（" +
        sw.ElapsedMilliseconds + "ミリ秒）です");
    }
  }
}
