﻿using System;
using System.Diagnostics;
using System.Text;
using System.Windows.Forms;

namespace Prime1 {
  public partial class Form1 : Form {
    public Form1() {
      InitializeComponent();
    }

    private void Form1_Load(
      object sender, EventArgs e) {

      textBoxResult.Dock = DockStyle.Fill;
      textBoxResult.ScrollBars = ScrollBars.Vertical;
      comboBoxMax.DropDownStyle =
        ComboBoxStyle.DropDownList;
      int[] maxValues = new int[] { 
        100, 1000, 10000, 100000, 1000000, 10000000, 100000000 };
      foreach (int maxValue in maxValues)
        comboBoxMax.Items.Add(maxValue.ToString());
      comboBoxMax.SelectedIndex = 0;
    }

    private void buttonSearch_Click(
      object sender, EventArgs e) {

      var sw = new Stopwatch();
      sw.Start();

      textBoxResult.Clear();
      int max = int.Parse(
        comboBoxMax.SelectedItem.ToString());
      int count = 1;

      var sb = new StringBuilder();
      sb.AppendLine("2");

      for (int i = 3; i <= max; i++) {
        bool isPrime = true;
        int limit =
          (int)Math.Ceiling(Math.Sqrt(i));
        for (int j = 2; j <= limit; j++)
          if (i % j == 0) {
            isPrime = false;
            break;
          }
        if (isPrime) {
          sb.AppendLine(i.ToString());
          count++;
        }
      }
      textBoxResult.Text = sb.ToString();

      //リスト8
      //var path = @"c:\temp\prime" +
      //  max.ToString() + ".txt";
      //var myEncoding = System.Text.Encoding.
      //  GetEncoding("Shift_JIS");
      //System.IO.File.WriteAllText(path,
      //  sb.ToString(), myEncoding);

      //リスト9
      //var path = @"c:\temp\prime" +
      //  max.ToString() + ".txt";
      //var myEncoding = System.Text.Encoding.
      //  GetEncoding("Shift_JIS");
      //var stWriter = new System.IO.StreamWriter(
      //  path, false, myEncoding);
      //stWriter.WriteLine("2");

      //for (int i = 3; i <= max; i++) {
      //  bool isPrime = true;
      //  int limit =
      //    (int)Math.Ceiling(Math.Sqrt(i));
      //  for (int j = 2; j <= limit; j++)
      //    if (i % j == 0) {
      //      isPrime = false;
      //      break;
      //    }
      //  if (isPrime) {
      //    stWriter.WriteLine(i.ToString());
      //    count++;
      //  }
      //}
      //stWriter.Close();

      sw.Stop();
      var ts = new TimeSpan(
        sw.ElapsedMilliseconds * 10000);
      MessageBox.Show(count +
        "個の素数が見付かりました。処理時間は" +
        sw.ElapsedMilliseconds + "ミリ秒（" +
        ts.ToString(@"hh\:mm\:ss") + "）でした");
    }
  }
}
