﻿Public Class Form1
  Private MainData As List(Of Person) = New List(Of Person)
  Private IndexValue As Integer = 0
  Public Property Index() As Integer
    Get
      Return IndexValue
    End Get
    Set(ByVal value As Integer)
      'If value >= 0 AndAlso value < MainData.Count Then
      IndexValue = value
      ShowData()
      'End If
    End Set
  End Property

  Private Sub ShowData()
    LabelPosition.Text = "#" & (Index + 1).ToString()
    TextBoxName.Text = MainData(Index).Name
    TextBoxBirthday.Text = MainData(Index).Birthday.ToShortDateString()
  End Sub


  Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
    LoadData()
    Index = 0
  End Sub

  Private Sub LoadData()
    Const dataFileName = "meibo1.csv"
    Const errorTitle = "エラー"
    Me.Text = "名簿"
    Dim myEncoding = System.Text.Encoding.GetEncoding("Shift_JIS")
    Dim input = ""
    Try
      input = System.IO.File.ReadAllText(dataFileName, myEncoding)
    Catch ex As Exception
      MessageBox.Show(ex.Message, errorTitle)
      Application.Exit()
    End Try

    Dim lines = input.Split({Environment.NewLine},
      System.StringSplitOptions.RemoveEmptyEntries)

    For Each line In lines
      Dim columns = line.Split(","c)
      Dim p As Person = Nothing
      Try
        p = New Person(columns(0), columns(1))
      Catch ex As Exception
        MessageBox.Show(dataFileName & "の" & (MainData.Count + 1) & "行め「" & line &
          "」に問題があります" & vbCrLf & ex.Message, errorTitle)
        Application.Exit()
      End Try
      If Not p Is Nothing Then MainData.Add(p)
    Next
  End Sub

  Private Sub ButtonPrevious_Click(sender As Object, e As EventArgs) Handles ButtonPrevious.Click
    Index -= 1
  End Sub

  Private Sub ButtonNext_Click(sender As Object, e As EventArgs) Handles ButtonNext.Click
    Index += 1
  End Sub
End Class
