﻿Public Class Form1
  Private Const DataFileName = "meibo1.csv"
  Private Const ErrorTitle = "エラー"
  Dim MyEncoding = System.Text.Encoding.GetEncoding("Shift_JIS")

  Private MainData As List(Of Person) = New List(Of Person)
  Private FirstTime As Boolean = True
  Private IndexValue As Integer = 0
  Public Property Index() As Integer
    Get
      Return IndexValue
    End Get
    Set(ByVal value As Integer)
      If SaveData() Then
        IndexValue = value
        ShowData()
        ButtonPrevious.Enabled = value <> 0
        ButtonNext.Enabled = value < MainData.Count - 1

        'If文で書いた例
        'If value = 0 Then
        '  ButtonPrevious.Enabled = False
        'Else
        '  ButtonPrevious.Enabled = True
        'End If

        'If value < MainData.Count - 1 Then
        '  ButtonNext.Enabled = True
        'Else
        '  ButtonNext.Enabled = False
        'End If
      End If
    End Set
  End Property

  Private Function SaveData() As Boolean
    If FirstTime Then
      FirstTime = False
      Return True
    End If

    Try
      MainData(Index).Birthday = Date.Parse(TextBoxBirthday.Text)
    Catch ex As Exception
      MessageBox.Show(ex.Message)
      TextBoxBirthday.Text = MainData(Index).Birthday.ToShortDateString()
      Return False
    End Try
    MainData(Index).Name = TextBoxName.Text
    Return True
  End Function

  Private Sub ShowData()
    LabelPosition.Text = "#" & (Index + 1).ToString()
    TextBoxName.Text = MainData(Index).Name
    TextBoxBirthday.Text = MainData(Index).Birthday.ToShortDateString()
  End Sub


  Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
    LoadData()
    Index = 0
  End Sub

  Private Sub LoadData()
    Me.Text = "名簿"
    Dim input = ""
    Try
      input = System.IO.File.ReadAllText(DataFileName, MyEncoding)
    Catch ex As Exception
      MessageBox.Show(ex.Message, ErrorTitle)
      Application.Exit()
    End Try

    Dim lines = input.Split({Environment.NewLine},
      System.StringSplitOptions.RemoveEmptyEntries)

    For Each line In lines
      Dim columns = line.Split(","c)
      Dim p As Person = Nothing
      Try
        p = New Person(columns(0), columns(1))
      Catch ex As Exception
        MessageBox.Show(dataFileName & "の" & (MainData.Count + 1) & "行め「" & line &
          "」に問題があります" & vbCrLf & ex.Message, ErrorTitle)
        Application.Exit()
      End Try
      If Not p Is Nothing Then MainData.Add(p)
    Next
  End Sub

  Private Sub ButtonPrevious_Click(sender As Object, e As EventArgs) Handles ButtonPrevious.Click
    Index -= 1
  End Sub

  Private Sub ButtonNext_Click(sender As Object, e As EventArgs) Handles ButtonNext.Click
    Index += 1
  End Sub

  Private Sub Form1_FormClosing(sender As Object, e As FormClosingEventArgs) Handles MyBase.FormClosing
    If Not SaveData() Then
      e.Cancel = True
    Else
      Dim result = MessageBox.Show("データを" & DataFileName & "に保存しますか？",
        "保存の確認", MessageBoxButtons.YesNo)
      If result = Windows.Forms.DialogResult.Yes Then
        Dim sb = New System.Text.StringBuilder()
        For Each p In MainData
          sb.AppendLine(p.Name & "," & p.Birthday.ToShortDateString())
        Next
        'Try
        System.IO.File.WriteAllText(DataFileName, sb.ToString(), MyEncoding)
        'Catch ex As Exception
        '  MessageBox.Show(ex.Message, ErrorTitle)
        'End Try
      End If
    End If
  End Sub
End Class
