﻿Public Class Form1
  Private KnownPrime() As Integer = {
    2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31,
    37, 41, 43, 47, 53, 59, 61, 67, 71, 73,
    79, 83, 89, 97}
  Private SearchedMax = 100

  Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
    ComboBoxMax.DropDownStyle = ComboBoxStyle.DropDownList
    Dim maxValues = {1000, 10000, 100000, 1000000, 10000000,
      100000000, 1000000000, 2000000000}
    For Each maxValue In maxValues
      ComboBoxMax.Items.Add(maxValue.ToString())
    Next
    ComboBoxMax.SelectedIndex = 0
  End Sub

  Private Sub ButtonSearch_Click(sender As Object, e As EventArgs) Handles ButtonSearch.Click
    Dim sw = New Stopwatch()
    sw.Start()
    Dim max = Integer.Parse(ComboBoxMax.SelectedItem.ToString())
    GetPrime(max)
    OutputKnownPrime()
    sw.Stop()

    Dim ts = New TimeSpan(sw.ElapsedMilliseconds * 10000)
    MessageBox.Show(KnownPrime.Length & "個の素数が見付かりました。処理時間は" &
      sw.ElapsedMilliseconds & "ミリ秒（" & ts.ToString("hh\:mm\:ss") & "）でした")
  End Sub

  Private Sub GetPrime(searchMax As Integer)
    If searchMax > 10000 AndAlso SearchedMax <= 100 Then GetPrime(1000)
    If searchMax > 1000000 AndAlso SearchedMax <= 1000 Then GetPrime(10000)
    If searchMax > 100000000 AndAlso SearchedMax <= 10000 Then GetPrime(100000)

    Dim i As Integer, j As Integer, limit As Integer
    Dim isPrime(searchMax) As Boolean
    Dim primeCount = 0
    Dim ub = isPrime.GetUpperBound(0)

    For i = 0 To ub
      isPrime(i) = True
    Next
    limit = Math.Ceiling(Math.Sqrt(ub))
    For i = 0 To KnownPrime.GetUpperBound(0)
      If KnownPrime(i) > limit Then Exit For
      For j = 2 To (searchMax \ KnownPrime(i))
        isPrime(KnownPrime(i) * j) = False
      Next
    Next

    For i = 2 To ub
      If isPrime(i) Then primeCount += 1
    Next

    ReDim KnownPrime(primeCount - 1)
    j = 0
    For i = 2 To ub
      If isPrime(i) Then
        KnownPrime(j) = i
        j += 1
      End If
    Next
    SearchedMax = searchMax
  End Sub

  Private Sub OutputKnownPrime()
    Dim path = "c:\temp\prime" & SearchedMax.ToString() & ".txt"
    Dim myEncoding = System.Text.Encoding.GetEncoding("Shift_JIS")
    Dim stWriter = New System.IO.StreamWriter(path, False, myEncoding)
    For Each prime In KnownPrime
      stWriter.WriteLine(prime.ToString())
    Next
    stWriter.Close()
  End Sub
End Class
